#!/usr/bin/env python

from sys    import argv, exit
from os     import environ, getuid
from pwd    import getpwuid
from socket import socket, fromfd, AF_UNIX, SOCK_STREAM
from re     import sub
from mpdlib import mpd_set_my_id, mpd_send_one_msg, mpd_recv_one_msg, mpd_raise, mpdError

def mpdtrace():
    mpd_set_my_id('mpdtrace_')
    if len(argv) > 1  and  ( argv[1] == '-h'  or  argv[1] == '--help') :
        print 'usage: mpdtrace [-l]'
        print '    The -l option shows full hostnames and listening ports'
        exit(-1)
    username = getpwuid(getuid())[0]    #### instead of environ['USER']
    if environ.has_key('UNIX_SOCKET'):
        conFD = int(environ['UNIX_SOCKET'])
        conSocket = fromfd(conFD,AF_UNIX,SOCK_STREAM)
    else:
        consoleName = '/tmp/mpd2.console_' + username
        conSocket = socket(AF_UNIX,SOCK_STREAM)  # note: UNIX socket
        try:
            conSocket.connect(consoleName)
        except Exception, errmsg:
            mpd_raise('cannot connect to local mpd')
            # mpd_raise('cannot connect to local mpd; errmsg: %s' % (str(errmsg)) )
    msgToSend = { 'cmd' : 'mpdtrace' }
    mpd_send_one_msg(conSocket,msgToSend)
    while 1:
        msg = mpd_recv_one_msg(conSocket)
        if (not msg.has_key('cmd')):
            raise RuntimeError, 'mpdtrace: INVALID msg=:%s:' % (msg)
        if (msg['cmd'] == 'mpdtrace_info'):
	    if len(argv) > 1 and argv[1] == '-l':
		print msg['id']
            else:
		print sub(r'[\._].*', '', msg['id'])    # strip off domain and port
            # printLine = msg['id'] + ': '
            # printLine = printLine + 'lhs=' + msg['lhs'] + ' '
            # printLine = printLine + 'rhs=' + msg['rhs'] + ' '
            # print 'mpdtrace: ', printLine
        else:
            break  # mpdtrace_trailer


if __name__ == '__main__':
    try:
        mpdtrace()
    except mpdError, errmsg:
	print 'mpdtrace failed: %s' % (errmsg)
